{% extends "base.html" %}
{% block subtitle %}
    Home
{% endblock subtitle %}

{% block content %}
<div class="jumbotron">
    <h1>OxD Python Demo Site</h1>
    <p>This is a demo site showcasing the OxD Python Library. The demo site is written in Python <a href="http://flask.pocoo.org">Flask</a> and shows the library can be used with the Flask to perform OpenID based authentication. </p>
</div>
<div class="row">
    <div class="col-md-12">
            </div>
</div>
    <div class="row">
        <div class="col-md-6">
            <h3>Configuration File</h3>
            <p>Website specific configuration information is stored in a config file. This is necessary for
               storing persistant information like Oxd ID generated during the site registration with the Open ID provider.
               The <code>demosite.cfg</code> shows the config file used for this demosite. The complete documentation about the config file can be obtained
               <a href="https://github.com/GluuFederation/oxd-python/blob/master/sample.cfg">here in Github</a>
            </p>
        </div>
        <div class="col-md-6">
            <h3>demosite.cfg</h3>
            <pre class="prettyprint">
[oxd]
host = localhost
port = 8099
id = 

[client]
op_host = https://gluu.example.com
application_type = web
authorization_redirect_uri = https://client.example.com/callback
redirect_uris = https://client.example.com/callback
post_logout_redirect_uri = https://client.example.com/
client_logout_uris = https://client.example.com/logout
contacts = demo@example.com</pre>
        </div>
    </div>
<div class="row">
    <div class="col-md-6">
        <h3>Initializing oxD Python</h3>
        <p>oxD Python is provides the <code>Client</code> class to perform all its operations. The client is to be initialzed with the config file
        location to that the site specific configuration like callback URLs could be registered with the OP</p>
    </div>
    <div class="col-md-6">
        <h3>Flask code</h3>
        <pre class="prettyprint lang-python">
import os
import oxdpython

from flask import Flask, request, redirect, render_template

this_dir = os.path.dirname(os.path.realpath(__file__))
config = os.path.join(this_dir, 'demosite.cfg')

app = Flask(__name__)
client = oxdpython.Client(config)
</pre>
    </div>
</div>
<div class="row">
    <div class="col-md-6">
        <h3>Step 0: Website registration (can be skipped)</h3>
        <p>The first step is to register the client with the OP. Once the client is registered, then the user data can be fetched upon user authorization.
        oxD Python performs client registration automatically when you request for an authorization url.</p>
    </div>
    <div class="col-md-6">
    <pre class="prettyprint lang-python noheader">
# this can be skipped. Registration happens automatically when you request for auth url

client.register_site()
</pre>
    </div>
</div>
<div class="row">
    <div class="col-md-6">
        <h3>Step 1: Get authorization URL</h3>
        <p><strong> Live demo. </strong><a class="btn btn-success btn-lg" href="{{ url_for('authorize') }}">Go to Authorization Page</a></p>
    </div>
    <div class="col-md-6">
    <pre class="prettyprint lang-python noheader">
@app.route('/authorize/')
def authorize():
    auth_url = client.get_authorization_url()
    return redirect(auth_url)
</pre>
    </div>
</div>
<div class="row">
    <div class="col-md-6">
    <h3>Step 2: Get user information</h3>
    <p>
        Parse the query string from the callback url after authorization, get the access token and use the token to get information.
    </p>
    </div>
    <div class="col-md-6">
    <pre class="prettyprint lang-python noheader">
@app.route('/callback')
def callabck():
    state = request.args.get('state')
    code = request.args.get('code')
    scopes = request.args.get('scope').split(" ")

    tokens = client.get_tokens_by_code(code, scopes, state)

    user = client.get_user_info(tokens.access_token)

    return render_template("home.html", user=user)
</pre>
    </div>
</div>
<div class="row">
    <div class="col-md-6">
        <h3>Step 3: Using the user claims</h3>
        <p>Once the user data is obtained, the various claims supported by the OP can be used as required.</p>
        {% if user %}
        <div class="alert alert-success">
            <p>
            User information provided by the OpenID Provider
            </p>
            {% for field in user._fields %}
                <p>{{ field }} = {{user|attr(field)}}</p>
            {% endfor %}
        </div>
        {% else %}
            <div class="alert alert-warning">You haven't authorized the demo user yet. Click the "Go to Authorization Page" button above</div>
        {% endif %}
    </div>
    <div class="col-md-6">
    <h3>Jinja Template code</h3>
{% raw %}
<pre class="prettyprint lang-jinja">
{% if user %}
&lt;div class="alert alert-success"&gt;
    {% for field in user._fields %}
        &lt;p&gt;{{ field }} = {{user|attr(field)}}&lt;/p&gt;
    {% endfor %}
&lt;/div&gt;
{% endif %}
</pre>
{% endraw %}
    </div>
</div>

<div class="row">
    <div class="col-md-6">
        <h3>Step 4: Logging Out</h3>
        <p>Once the required work is done the user can be logged out of the system.</p>
        <p>Live Demo: <a class="btn btn-danger btn-lg" href="/logout">Logout</a></p>
        {% if logout_html %}
        <div class="alert alert-success">
            Logout returned html {{logout_html}}
        </div>
        {% endif %}
    </div>
   <div class="col-md-6">
    <pre class="prettyprint lang-python noheader">
@app.route('/logout')
def logout():
    logout_url = oxc.get_logout_uri()
    return redirect(logout_url)
</pre>
    </div>
</div>

{% endblock content %}
